/*
 * test some automatically generated data types
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "datatypes.h"

/*
illist_is_nil,
illist_is_cons,

#define illist_nil() ((illist)NULL)
extern illist illist_cons( intlist , illist );
extern kind_of_illist illist_kind( illist );
extern void get_illist_cons( illist , intlist * , illist * );
extern void print_illist( FILE *, illist );

idtree_is_leaf,
idtree_is_node,

extern idtree idtree_leaf( string );
extern idtree idtree_node( idtree , idtree );
extern kind_of_idtree idtree_kind( idtree );
extern void get_idtree_leaf( idtree , string * );
extern void get_idtree_node( idtree , idtree * , idtree * );
extern void print_idtree( FILE *, idtree );
*/

void test( int condition, char *string )
{
	if( condition )
	{
		printf( "%s: ok\n", string );
	} else
	{
		printf( "%s: fail\n", string );
	}
}


int main( void )
{
	intlist l = intlist_nil();
	test( intlist_kind( l ) == intlist_is_nil,
		"kind(nil) == nil" );

	l = intlist_cons( 100, l );

	test( intlist_kind( l ) == intlist_is_cons,
		"kind([100]) == cons" );

	intlist tail;
	int head;
	get_intlist_cons( l, &head, &tail );
	test( head == 100, "head([100]) == 100" );
	test( intlist_kind( tail ) == intlist_is_nil,
		"kind(tail([100])) == nil" );

	l = intlist_cons( 200, l );
	get_intlist_cons( l, &head, &tail );
	test( head == 200, "head([200,100]) == 200" );
	get_intlist_cons( tail, &head, &tail );
	test( head == 100, "head(tail([200,100])) == 100" );

	l = intlist_cons( 300, l );
	l = intlist_cons( 400, l );

	int sum = 0;
	intlist p = l;
	while( intlist_kind(p) == intlist_is_cons )
	{
		int head;
		intlist tail;
		get_intlist_cons( p, &head, &tail );
		sum += head;
		p = tail;
	}
	test( sum == 1000, "sum 1000" );

	exit(0);
	return(0);
}
